// Public vs private access. 
class MyClass {  
  // every instance has the instance variables and methods
  // even if they are private
  private int alpha; // private access 
  public int beta; // public access 
  int gamma; // default access, package if we declare a package, otherwise public 
 
  /* Methods to access alpha.  It is OK for a 
     member of a class to access a private member 
     of the same class. 
  */ 
  void setAlpha(int a) {
  // runtime arg gets passed to the formal parameter a
    alpha = a;  // assignment to the private instance variable
  } 
 
  int getAlpha() { 
    return alpha; 
  } 
}  
  
class AccessDemo {  
  public static void main(String args[]) {  
    // instantiating an object of type MyClass
    // calling the constructor
    MyClass ob = new MyClass();  
  
    /* Access to alpha is allowed only through 
       its accessor methods. */ 
    ob.setAlpha(-99);  // passing a runtime arg 
    System.out.println("ob.alpha is " + ob.getAlpha()); 
 
    // You cannot access alpha like this: 
  //ob.alpha = 10; // Wrong! alpha is private! 
 
    // These are OK because beta and gamma are public. 
    ob.beta = 88;  
    ob.gamma = 99;  
   }  
}