/* First Course in Java, EDP 123158
   Homework#4
   Student#110, SANDS, Ronald
   Class AsciiCharDemo prompts the user to enter a mixed case sentence.
   It echoes the original sentence, then displays the sentence:
      CONVERTED TO ALL UPPER CASE.
      converted to all lower case.
   and   Converted to sentence case.

Sample output:

   Enter a sentence in mixed case:
   thIS IS an ExaMplE of a MixeD cASe sentENCE.
   Initial value: thIS IS an ExaMplE of a MixeD cASe sentENCE.
   Upper case: THIS IS AN EXAMPLE OF A MIXED CASE SENTENCE.
   Lower case: this is an example of a mixed case sentence.
   Sentence case: This is an example of a mixed case sentence.

*/
import java.io.*;

class AsciiChar
{
   private char[] toConvert;
   private String Converted;
   private int NumOfChars;

   // Constructor builds a character array from the input string
   // and initializes the Converted string equal to the input string.
   AsciiChar(String N)
   {
      int L = N.length();
      toConvert = new char[L];
      for (int i = 0; i < L; i++)
         toConvert[i] = N.charAt(i);
      Converted = N;
   }

   // Returns the current value of the Converted string,
   // which is initially equal to the input string.
   String nocase() {
      return Converted;
   }

   // Returns the input string converted to all upper case.
   // Each lower case character in the character array is
   // converted to upper case by subtracting 32 from its Ascii value.
   // Each character is then appended to the Converted string.
   String upcase() {
      Converted = "";
      for (int i = 0; i < toConvert.length; i++)
      {
         if (toConvert[i] >= 'a' & toConvert[i] <= 'z')
            toConvert[i] -= 32;
         Converted += toConvert[i];
      }
      return Converted;
   }

   // Returns the input string converted to all lower case.
   // Each upper case character in the character array is
   // converted to lower case by adding 32 to its Ascii value.
   // Each character is then appended to the Converted string.
   String lowcase() {
      Converted = "";
      for (int i = 0; i < toConvert.length; i++)
      {
         if (toConvert[i] >= 'A' & toConvert[i] <= 'Z')
            toConvert[i] += 32;
         Converted += toConvert[i];
      }
      return Converted;
   }

   // Returns the input string converted to sentence case.
   // The first character is converted to upper case by subtracting 32.
   // All other characters are converted to lower case by adding 32.
   // Each character is then appended to the Converted string.
   String sntcase() {
      Converted = "";
      if (toConvert[0] >= 'a' & toConvert[0] <= 'z')
         toConvert[0] -= 32;
      Converted += toConvert[0];
      for (int i = 1; i < toConvert.length; i++)
      {
         if (toConvert[i] >= 'A' & toConvert[i] <= 'Z')
            toConvert[i] += 32;
         Converted += toConvert[i];
      }
      return Converted;
   }
}


public class AsciiCharDemo
// Driver program to demonstrate the AsciiChar class.
{
  public static void main(String[] args)
  {
  try {
   BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
   System.out.println("Enter a sentence in mixed case:");
   String demoStr = br.readLine();

   AsciiChar demoString = new AsciiChar(demoStr);

   System.out.println("Initial value: " + demoString.nocase());
   System.out.println("Upper case: " + demoString.upcase());
   System.out.println("Lower case: " + demoString.lowcase());
   System.out.println("Sentence case: " + demoString.sntcase());
   return;
  }
  catch (IOException e) {
     System.out.println("Error: " + e);
  }
  }
}
