// Demonstrate method overloading.
// Each signature must be unique
// based on parameters to match
// runtime args in the method calls:
// type of args, order of args, number of args
class OverloadDemo
{
  // simplest signature declares no parameters
  void test()
  {
    System.out.println("No parameters");
  }

  // Overload test for one integer parameter.
  // the integer a is a formal parameter
  void test(int a)
  {
    System.out.println("a: " + a);
  }

/*test if return value makes signature unique
  int test(int a)
  {
    System.out.println("a: " + a);
    return a;
  } // does it compile if uncommented?
*/

  // Let's try a boolean
  void test(boolean b)
  {
    System.out.println("b: " + b);
  }

  // Overload test for two integer parameters.
  //int test(int a, int b)
  void test(int a, int b)
  {
    System.out.println("a and b: " + a + " " + b);
    //return true;
  }

  // overload test for one double parameter
  double test(double a)
  {
    System.out.println("double a: " + a);
    return a*a;  // return a double
  }
}

class Overload
{
  public static void main(String args[])
  {
    // create an object that inherits
    // the methods of the OverloadDemo class
    // we are using the default constructor
    // ob is the identifier for the object
    OverloadDemo ob = new OverloadDemo();
    double result; // declaration

    // call all versions of test() on the one object
    ob.test();  // calling the method on the object
    ob.test(2+2==5);  // call the version of the overloaded method that takes exactly one parameter, namely a boolean
    ob.test(10); // signature with one int
    ob.test(10, 20);  // a signature with TWO ints
    result = ob.test(2.1);

    // uncomment next line to break the compiler with String parameter
    //ob.test("Willy Wonka Loves Chocolate Tea");
    System.out.println("Result of ob.test(2.1): " + result);
  }
}