// Demonstrate an overloaded constructor. 
class MyClass {  
  int x;  // x is an instance variable
  //private int y;
  
  /* Although this LOOKS like the default constructor, the default constructor in this
  no longer exist because I define an custom
  constructor.
  */
  MyClass() { 
    System.out.println("Inside MyClass()."); 
    x = 0; // assign the value of zero to x
  } 
 
  MyClass(int i) {  
    System.out.println("Inside MyClass(int)."); 
    x = i;  // assign the value of the formal parameters--which came from the runtime arg--to the instance variable
  } 
 
  MyClass(double d) { 
    System.out.println("Inside MyClass(double)."); 
    x = (int) d; // as int 17
  } 
 
  MyClass(int i, int j) { 
    System.out.println("Inside MyClass(int, int)."); 
    x = i * j;  // assign the value of the instance variable to correspond to that of the formal parameters 
  }    
}    
    
class OverloadedConstructorDemo {    
  public static void main(String args[]) 
  {  
    // create 4 instances of type MyClass
    // the first creation of an object calls the constructor that takes no arg
    // the runtime args correspond to different versions of the overloaded constructor
    MyClass t1 = new MyClass();  // NOT the default constructor 
    MyClass t2 = new MyClass(88);  // calling the constructor on line 10 - one int
    MyClass t3 = new MyClass(17.23); // double  
    MyClass t4 = new MyClass(2, 4); // 2 ints 
  
    // use instance variables on objects 
    System.out.println("t1.x: " + t1.x); 
    System.out.println("t2.x: " + t2.x); 
    System.out.println("t3.x: " + t3.x); 
    System.out.println("t4.x: " + t4.x); 
  }    
}