// EDP #123158, First Course in Java - Homework #4, Student #115
// -------------------------------------------------------------
/*
  The ShapeCalc class implements an application that uses
  mulitiple levels of inheritance.  Inheritance is implemented
  using the Extends operator and demonstrates;
  1. The use of Constructors with Formal Parameters
  2. Methods that return a value
  3. Takes input from the User for use in the resulting output
  Three basic shapes are available in this program; Circle,
  Triangle and Rectangle.
*/

// Prepare for I/O
import java.io.*;   // Specifies the package Java will use for Input/Output classes

// Define parameterized class MyShape
class MyShape {
   double width;
   double height;

   // Parameterized constructor invoked by subclass reference to super
   MyShape(double w, double h) {
      width = w;
      height = h;
   } // method MyShape
} // class MyShape

class TwoDShape extends MyShape {
   private int numberofsides;

   TwoDShape(double w, double h, int s) {
      super(w, h); // Initialize width & height through superclass constructor
      numberofsides = s;
   } // constructor TwoDShape

    // Define method myPerimeter and calculate perimeter
   double myPerimeter() {         // Declare method
      double shapeperimeter = 0;
      switch(numberofsides) {
         case 1:
            // 1 side is a circle
            shapeperimeter = width * height * 2; // Calc perimeter
            break;
         case 3:
            // 3 sides is a triangle
               double hypotenuse = Math.sqrt((width * width) + (height * height));
            shapeperimeter = width + height + hypotenuse; // Calc perimeter
            break;
         case 4:
               // 4 sides is a rectangle
            shapeperimeter = (width + height) * 2; // Calc perimeter
            break;
      } // end switch
   return shapeperimeter;
   } // end method myPerimeter

   // Define method myArea and calculate area
   double myArea() {               // Declare method
      double shapearea = 0;
      switch(numberofsides) {
         case 1:
            // 1 side is a circle
            shapearea = width * width * height; // Calc area
            break;
         case 3:
               // 3 sides is a triangle
               shapearea = width * height / 2; // Calc area
            break;
         case 4:
            // 4 sides is a rectangle
            shapearea = width * height; // Calc area
            break;
      } // end switch
   return shapearea;
   } // end method myArea

   // Define method to set dimensions of shape. No Parms returned
   void setDim(double w, double h, int n) {
    width  = w;
    height = h;
    numberofsides = n;
   } // end method setDim
} // end class TwoDShape

// Define major class ShapeCalcIO
// ------------------------------
class ShapeCalcIO {
   public static void main(String args[])
   throws java.io.IOException {
      double w1 =0, h1 = 0;
      int numberofsides = 0, nos = 0;
      String inpOption;
      int option = 0;
      String myShapeName = null;

      // Create shape objects
      TwoDShape myCircle = new TwoDShape(w1, h1, nos); // Create an instance of TwoDShape; myCircle
      TwoDShape myTriangle = new TwoDShape(w1, h1, nos); // Create an instance of TwoDShape; myTriangle
      TwoDShape myRectangle = new TwoDShape(w1, h1, nos); // Create an instance of TwoDShape; myRectangle
      double Area=0, Perimeter=0;

      // establish instance of buffer reader
      BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

      // Request shape from Command Line
      System.out.println("\nChoose a shape:");
      System.out.println("1. Circle");
      System.out.println("2. Triangle");
      System.out.println("3. Rectangle\n");

      do { // Loop until valid response...

         // Get option from Command Prompt
         inpOption = br.readLine();

         // Monitor for exception errors
         try {
            option = Integer.parseInt(inpOption);
            switch(option) {
                  case 1:
                     // Set number of sides for a circle
                     numberofsides = 1;
                     myShapeName = "Circle";
                     // Initialize dimensions
                  myCircle.setDim(3, Math.PI, 1);
                     break;
                  case 2:
                        // Set number of sides for a triangle
                     numberofsides = 3;
                     myShapeName = "Triangle";
                     // Initialize dimensions
                  myTriangle.setDim(15, 25, 3);
                     break;
               case 3:
                        // Set number of sides for a rectangle
                     numberofsides = 4;
                     myShapeName = "Rectangle";
                     // Initialize dimensions
                  myRectangle.setDim(12, 30, 4);
                     break;
               } // end switch
            } // end try

            // Exception handling for non numeric value returned from Command Prompt
            catch (NumberFormatException exc){
            System.out.println("\nPlease specify valid numeric option only!");
            } // end catch
         } // end do
      while (!inpOption.equals("1") & !inpOption.equals("2") & !inpOption.equals("3"));


      // Calculate area and perimeter by invoking methods of instance of shape
      switch(option) {
         case 1:
               Area = myCircle.myArea();
               Perimeter = myCircle.myPerimeter();
               break;
            case 2:
            Area = myTriangle.myArea();
            Perimeter = myTriangle.myPerimeter();
               break;
            case 3:
            Area = myRectangle.myArea();
            Perimeter = myRectangle.myPerimeter();
            break;
      } // end switch

      // Print results on Command Prompt
         System.out.println("Area of " + myShapeName + " is " + Area);
      System.out.println("Perimeter of " + myShapeName + " is " + Perimeter);
   } // end main
} // end class ShapeCalcIO